/* 2 September 2001, Alexandros Droseltis */
/* This file includes the print-funcions, i.e. the functions that print the output of the programm
   on the screen or on the file */

void print_score(int plithos, char infilename[], char input1[][12][2], char input2[][12][2], char input3[][12][2], char input4[][12][2], char title[], int opt[]);
void print_slice(int plithos, char infilename[], char input[][12][2], char type[], int opt[]);
void clear_file(char infilename[]);
int accid_filt(int k, int i, char input[][12][2]);
void barline(char infilename[]);
void tetragono(int plithos, int Prime[12][12][2], int Inversion0[12][2], int opt[]);
void print_version();

void print_score(int plithos, char infilename[], char input1[][12][2], char input2[][12][2], char input3[][12][2], char input4[][12][2], char title[], int opt[])
{
  int i, j, summe;
  char type1[3], type2[3], type3[3], type4[3];
  FILE *outfile;

  outfile=fopen(infilename, "a");

  fprintf(outfile, "\\input musixtex\n");
  fprintf(outfile, "\\input musixmad\n\n");

  fprintf(outfile, "\\def\\sp{\\off{0.333\\noteskip}}\n\n");
  fprintf(outfile, "\\def\\numbone#1{\\zcharnote{-7}{\\smalltype #1}}\n");
  fprintf(outfile, "\\def\\numbtwo#1{\\zcharnote{-7}{\\loffset{0.5}{\\smalltype #1}}}\n");

  fprintf(outfile, "\\instrumentnumber{12}\n");
  for(i=0; i<=12; i++)
    {
      fprintf(outfile, "\\setname{%d}{%d}\n", i, 12-i);
    }
  fprintf(outfile, "\\interinstrument = 20pt\n");
  fprintf(outfile, "\\nobarnumbers\n");
  fprintf(outfile, "\\nopagenumbers\n");
  fprintf(outfile, "\\nostartrule\n");
  fprintf(outfile, "\\parindent 10pt\n");
  fprintf(outfile, "\\smallmusicsize\n");
  fprintf(outfile, "\\smallaccid\n");
  fprintf(outfile, "\\hsize=193mm");

  fprintf(outfile, "\\voffset -1.25in\n");
  fprintf(outfile, "\\hoffset -0.5in\n");
  fprintf(outfile, "\\centerline{\\BIgtype %s}\n", title);
  fprintf(outfile, "\\vskip 30pt\n");

  fprintf(outfile, "\n\\startextract\n");
  fclose(outfile);

  strcpy(type1, "P");
  strcpy(type2, "R");
  strcpy(type3, "I");
  strcpy(type4, "RI");

  summe=opt[4]+opt[5]+opt[6]+opt[7];

  if(opt[4]==0 || summe==4) print_slice(plithos, infilename, input1, type1, opt);
  if(opt[4]+opt[5]==0 || opt[4]+opt[6]==0 || opt[4]+opt[7]==0 || summe==4) barline(infilename);

  if(opt[5]==0 || summe==4) print_slice(plithos, infilename, input2, type2, opt);
  if(opt[5]+opt[6]==0 || opt[5]+opt[7]==0 || summe==4) barline(infilename);

  if(opt[6]==0 || summe==4) print_slice(plithos, infilename, input3, type3, opt);
  if(opt[6]+opt[7]==0 || summe==4) barline(infilename);

  if(opt[7]==0 || summe==4) print_slice(plithos, infilename, input4, type4, opt);

  outfile=fopen(infilename, "a");
  fprintf(outfile, "\\endextract\n");
  if(opt[0]==1) fprintf(outfile, "\\end");
  fclose(outfile);
}

void barline(char infilename[])
{
  FILE *outfile;
  outfile=fopen(infilename, "a");
  fprintf(outfile, "\\bar\n");
  fclose(outfile);
}

void print_slice(int plithos, char infilename[], char input[][12][2], char type[], int opt[])
{
  int i, j;
  FILE *outfile;

  outfile=fopen(infilename, "a");
  fprintf(outfile, "\\notes%%\n");
  for(j=0; j<11; j++)
    {
      //fprintf(outfile, "\\sp");
      for(i=0; i<plithos; i++)
	{
	  if(opt[1]==1)
	    {
	  if(i+1<10) fprintf(outfile, "\\numbone{%d}", i+1);
	  else fprintf(outfile, "\\numbtwo{%d}", i+1);
	    }
	  fprintf(outfile, "\\nq{");
	  if(accid_filt(11-j, i, input)==1) fprintf(outfile, "%c", input[11-j][i][0]);
	  fprintf(outfile, "%c}%%\n", input[11-j][i][1]);
	}
      fprintf(outfile, "&%%\n");

    }
  fprintf(outfile, "\\Uptext{\\BIgtype %s}%%\n", type);
  
  for(i=0; i<plithos; i++)
    {
      if(opt[1]==1)
	{
      if(i+1<10) fprintf(outfile, "\\numbone{%d}", i+1);
      else fprintf(outfile, "\\numbtwo{%d}", i+1);
	}
      fprintf(outfile, "\\nq{");
      if(accid_filt(0, i, input)==1) fprintf(outfile, "%c", input[0][i][0]);
      fprintf(outfile, "%c}%%\n", input[0][i][1]);
    }
  fprintf(outfile, "\\en\n");
  fclose(outfile);
}

void clear_file(char infilename[])
{
  FILE *outfile;
  outfile=fopen(infilename, "w");
  fprintf(outfile, "");
  fclose(outfile);
}

/* NAME: accid_filt
   FUNCTION: The function "accid_filt" gets rid of the unessasary accidantals,
             i.e. if the naturals that are not needed.
	     It lets only:
             a) sharps and flats
             b) naturals of those notes, that are noted before with a sharp or a flat.
   INPUT:    The row (input) with its transposition inticator (k) and the indicator of the note
             that should be checked (i).
   OUTPUT:   Number 1, if the accidental SHOULD be printed;
             Number 2, if the accidental SHOULD NOT be printed.
*/

int accid_filt(int k, int i, char input[][12][2])
{
  int j;

  /* IF THE ACCIDENTAL OF THE NOTE IS NOT A NATURAL, RETURN 1 (LET IT BE PRINTED). */
  if(input[k][i][0]!='=') return (1);

  /* IF THE ACCIDENTAL OF THE NOTE IS A NATURAL... */
  else
    {
      /* if the note is the first one of the row, return 0
	 (do not let the natural be printed); */
      if(i==0) return (0);
      /* if the note is not the first one... */
      else
	{
	  /* ... start checking the accidentals of the previous notes. */
	  for(j=i; j>0; j--)
	    {
	      /* If a note is found, that has the same last name (without accidental),
		 stop the process of checking. */
	      if(input[k][i][1]==input[k][j-1][1])
		{
		  if(input[k][j-1][0]!='=')
		    {
		      return(1);
		      break;
		    }
		  if(input[k][j-1][0]=='=')
		    {
		      return(0);
		      break;
		    }
		}
	    }
	  /* If the counter (j) has reached the value of the index number
	     of the note that is being checked,
	     (i.e. there is not a previous note whith the same last name),
	     return 0 (do not let the natural be printed);
	     If not, return 1 */
	  if(j==0) return (0);
	}
    }
}

void tetragono(int plithos, int Prime[12][12][2], int Inversion0[12][2], int opt[])
{
  int i, j, head;
  char g_note[6];

  if(opt[8]!=1)
    {
      for(i=0; i<plithos; i++)
	{
	  head=chromatic(Inversion0[i][0], Inversion0[i][1]);
	  for(j=0; j<plithos; j++)
	    {
	      german_names(Prime[head][j][0], Prime[head][j][1], g_note);
	      printf("%s\t", g_note);
	    }
	  printf("\n");
	}
    }

  if(opt[8]!=1 && opt[9]!=1) printf("\n");

  if(opt[9]!=1)
    {
      for(i=0; i<plithos; i++)
	{
	  head=chromatic(Inversion0[i][0], Inversion0[i][1]);
	  for(j=0; j<plithos; j++)
	    {
	      printf("%2d\t", chromatic(Prime[head][j][0], Prime[head][j][1]));
	    }
	  printf("\n");
	}
    }
}

void print_version()
{
  printf("TTRM version 1.5 (February 2002)\n\n");
  printf("(C) Copyright by A. Droseltis\n");
  printf("This is free software. See the documentation for more details.\n");
  printf("It is distributed without any warranty.\n");
}
