/* 2 September 2001, Alexandros Droseltis */

int accid2num(char x);
char num2accid(int x);
int notename2num(char x);
char num2notename(int x);
void german_names(int x, int y, char g_note[]);
int basic_german(char x);
int octave_german(char x);
int accid2num_german(char x[]);

/* The function "accid2num" changes the accidentals into numbers according to the following
   scheme */
int accid2num(char x)
{
  if(x=='<') return (-2);
  else if(x=='_') return (-1);
  else if(x=='=') return (0);
  else if(x=='^') return (1);
  else if(x=='>') return (2);
}

/* The function "num2accid" changes the numbers into accidentals
   according to the following scheme */
char num2accid(int x)
{
  if(x==-2) return ('<');
  else if(x==-1) return ('_');
  else if(x==0) return ('=');
  else if(x==1) return ('^');
  else if(x==2) return ('>');
}

/* The function "accid2num" changes the names of the notes (whithout accidentals) into
   numbers according to the following scheme */
int notename2num(char x)
{
  if(x=='C') return (0);
  else if(x=='D') return (1); 
  else if(x=='E') return (2);
  else if(x=='F') return (3);
  else if(x=='G') return (4);
  else if(x=='H') return (5);
  else if(x=='I') return (6);
  else if(x=='J') return (7);
  else if(x=='K') return (8);
  else if(x=='L') return (9);
  else if(x=='M') return (10);
  else if(x=='N') return (11);
  else if(x=='a') return (12);
  else if(x=='b') return (13);
  else if(x=='c') return (14);
  else if(x=='d') return (15);
  else if(x=='e') return (16);
  else if(x=='f') return (17);
  else if(x=='g') return (18);
  else if(x=='h') return (19);
  else if(x=='i') return (20);
  else if(x=='j') return (21);
  else if(x=='k') return (22);
  else if(x=='l') return (23);
  else if(x=='m') return (24);
  else if(x=='n') return (25);
  else if(x=='o') return (26);
  else if(x=='p') return (27);
  else if(x=='q') return (28);
  else if(x=='r') return (29);
  else if(x=='s') return (30);
  else if(x=='t') return (31);
  else if(x=='u') return (32);
  else if(x=='v') return (33);
  else if(x=='w') return (34);
  else if(x=='x') return (35);
  else if(x=='y') return (36);
  else if(x=='z') return (37);
}

/* The function "num2notename" changes the numbers into notenames
   according to the following scheme */
char num2notename(int x)
{
  if(x==0) return ('C');
  else if(x==1) return ('D'); 
  else if(x==2) return ('E');
  else if(x==3) return ('F');
  else if(x==4) return ('G');
  else if(x==5) return ('H');
  else if(x==6) return ('I');
  else if(x==7) return ('J');
  else if(x==8) return ('K');
  else if(x==9) return ('L');
  else if(x==10) return ('M');
  else if(x==11) return ('N');
  else if(x==12) return ('a');
  else if(x==13) return ('b');
  else if(x==14) return ('c');
  else if(x==15) return ('d');
  else if(x==16) return ('e');
  else if(x==17) return ('f');
  else if(x==18) return ('g');
  else if(x==19) return ('h');
  else if(x==20) return ('i');
  else if(x==21) return ('j');
  else if(x==22) return ('k');
  else if(x==23) return ('l');
  else if(x==24) return ('m');
  else if(x==25) return ('n');
  else if(x==26) return ('o');
  else if(x==27) return ('p');
  else if(x==28) return ('q');
  else if(x==29) return ('r');
  else if(x==30) return ('s');
  else if(x==31) return ('t');
  else if(x==32) return ('u');
  else if(x==33) return ('v');
  else if(x==34) return ('w');
  else if(x==35) return ('x');
  else if(x==36) return ('y');
  else if(x==37) return ('z');
}

/* The following function changes numbers into the german note names. */
void german_names(int x, int y, char g_note[])
{
  int note;

  note=y%7;
  switch(note)
    {
    case 0: g_note[0]='c';
      break;

    case 1: g_note[0]='d';
      break;

    case 2: g_note[0]='e';
      break;

    case 3: g_note[0]='f';
      break;

    case 4: g_note[0]='g';
      break;

    case 5: g_note[0]='a';
      break;

    default: g_note[0]='h';
    }

  /********** Accidental translator **********/
  /* If the accidental is a flat, */
  if(x==-1)
    {
      /* ... and the note is not a H, an E or an A... */
      if(note!=2 && note!=5 && note!=6)
	{
	  g_note[1]='e';
	  g_note[2]='s';
	  g_note[3]='\0';
	}
      /* If the note is an E or a A... */
     else if(note==2 || note==5)
       {
	 g_note[1]='s';
	 g_note[2]='\0';
       }
     /* If the note is a H... */
     else
       {
	 g_note[0]='b';
	 g_note[1]='\0';
       }
    }
  else if(x==1)
    {
      g_note[1]='i';
      g_note[2]='s';
      g_note[3]='\0';
    }
  else if(x==-2)
    {
      /* ... and the note is not a H, an E or an A... */
      if(note!=2 && note!=5 && note!=6)
	{
	  g_note[1]='e';
	  g_note[2]='s';
	  g_note[3]='e';
	  g_note[4]='s';
	  g_note[5]='\0';
	}
      /* If the note is an E or a A... */
     else if(note==2 || note==5)
       {
	 g_note[1]='s';
	 g_note[2]='e';
	 g_note[3]='s';
	 g_note[4]='\0';
       }
     /* If the note is a H... */
     else
       {
	 g_note[0]='b';
	 g_note[1]='e';
	 g_note[2]='s';
	 g_note[3]='\0';
       }
    }
  else if(x==2)
    {
      g_note[1]='i';
      g_note[2]='s';
      g_note[3]='i';
      g_note[4]='s';
      g_note[5]='\0';
    }
  else if(x==0) g_note[1]='\0';
}

int basic_german(char x)
{
  switch(x)
    {
    case 'c': return 7;
      break;
    case 'd': return 8;
      break;
    case 'e': return 9;
      break;
    case 'f': return 10;
      break;
    case 'g': return 11;
      break;
    case 'a': return 12;
      break;
    case 'h': return 13;
      break;
    default: return 13;
    }
}

int octave_german(char x)
{
  switch(x)
    {
    case '1': return 1;
      break;
    case '2': return 2;
      break;
    case '3': return 3;
      break;
    default: return 0;
    }
}


int accid2num_german(char x[])
{
  /* If the name of the note is Nx or N (N is a name of a notehead,
     and x the octave number)... */
  if(isdigit(x[1])!=0 || x[1]=='\0')
    {
      /* if the name of the notehead is NOT "b", the accidental is natural;
	 else (if the name of the notehead IS "b"), the accidental is flat. */
      if(x[0]!='b') return 0;
      else return -1;
    }
  else
    {
      /* SHARP, DOUBLE SHARP */
      if(x[1]=='i' && x[2]=='s')
	{
	  if(isdigit(x[3])!=0 || x[3]=='\0') return 1;
	  else if(x[3]=='i' && x[4]=='s') return 2;
	}
      /* FLAT, DOUBLE FLAT */
      /* if the notehead is NOT an "e", "a" or "b flat": */
      else if(x[0]!='e' && x[0]!='a' && x[0]!='b')
	{
	  /* if the accidental is a flat: */
	  if(x[1]=='e' && x[2]=='s')
	    {
	      /* if it is NOT double flat: */
	      if(isdigit(x[3])!=0 || x[3]=='\0') return -1;
	      /* if it IS double flat: */
	      else if(x[3]=='e' && x[4]=='s') return -2;
	    }
	}
      /* if the notehead IS an "e", "a": */
      else if(x[0]=='e' || x[0]=='a')
	{
	  /* if the accidental is a flat: */
	  if(x[1]=='s')
	    {
	      /* if it is NOT double flat: */
	      if(isdigit(x[2])!=0 || x[2]=='\0') return -1;
	      /* if it IS double flat: */
	      else if(x[2]=='e' && x[3]=='s') return -2;
	    }
	}
      /* if the name of the notehead IS a "b flat": */
      else if(x[0]=='b')
	{
	  /* if it has NOT a flat ending (-es): */
	  if(isdigit(x[1])!=0 || x[1]=='\0') return -1;
	  /* if it DOES have a flat ending (-es): */
	  else if(x[2]=='e' && x[3]=='s') return -2;
	}
    }
}
